from .core.interface import MiddlewareInterface as MiddlewareInterface
from .core.interface import EngineInterface as EngineInterface

from .core.core import Middleware as Middleware
from .core.core import Engine as Engine
from .core.core import ExecutePipeline as ExecutePipeline
from .core.echo import EchoMiddleware as EchoMiddleware
from .core.echo import EchoEngine as EchoEngine
from .core.tee import TeeEngine as TeeEngine

from .engine.stream_engine import StreamEngine as StreamEngine
from .engine.asr_engine import ASREngine as ASREngine
from .engine.tts_engine import TTSEngine as TTSEngine
from .engine.nlu_engine import NLUEngine as NLUEngine
from .engine.chat_ai_engine import ChatAIEngine as ChatAIEngine


from .plugins.dynamic_package_import import dynamic_package_import as dynamic_package_import
from .plugins.plugins_conf import PluginsConfig as PluginsConfig
from .plugins.plugins import Plugins as Plugins

# from .utils.logger import setup_logger as setup_logger
import logging
from sys import stdout
logger = logging.getLogger(__name__)
logger.setLevel(logging.INFO)
stream_handle = logging.StreamHandler(stdout)
formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s',
                              datefmt="%Y-%m-%d %H:%M:%S")
stream_handle.setFormatter(formatter)
logger.addHandler(stream_handle)
logger.propagate = False