import sys
from typing import Generator, Iterator, List, Optional
from .. import Middleware, MiddlewareInterface, Engine

class EchoMiddleware(Middleware):
    def __init__(self, next_middleware: Optional[List[MiddlewareInterface]] = []):
        super().__init__(self._process, next_middleware)
    def _process(self, data):
        if isinstance(data, Iterator):
            ret = ''
            for i in data:
                ret += i
                sys.stdout.write(i)
                sys.stdout.flush()
            sys.stdout.write('\n')
        else:
            ret = data
            print(data)
        return ret

class EchoEngine(Engine):
    def execute(self, data):
        if isinstance(data, Generator):
            ret = ''
            for i in data:
                ret += i
                sys.stdout.write(i)
                sys.stdout.flush()
            sys.stdout.write('\n')
        else:
            ret = data
            print(data)
        return ret